#!/usr/local/bin/python

import string, os

source_dir   = "/home/cmwilson/public_html/src/"
dest_dir     = "/home/cmwilson/public_html/"
include_dir  = "/home/cmwilson/public_html/src/includes/"
excluded_dirs = [include_dir]

def pre2html (title, file):
    return ("<html>\n" +
	    "<head><title>" +
	    title +
	    "</title></head>\n" +
	    "<body>\n" +
	    "<pre>\n" +
	    file +
	    "</pre>\n" +
	    "</body>\n" +
	    "</html>\n")

def prehtml2html (source):
    f = os.popen ("m4 -I%s %s" % (include_dir, source), "r")
    text = f.read ()
    f.close ()
    return text

def age (file):
    mtime = 8
    try:
	desc_tuple = os.stat (file)
    except os.error:
	return 0			# if file (htmlfile) doesn't exist
    return desc_tuple[8]		# it is always later than the sourcefile

def src2targetpath (srcpath):
    dirs = string.split (srcpath, "/")
    dirs = filter (lambda x: x != "src", dirs)
    targetpath = string.joinfields (dirs, "/")
    return targetpath

def make_executable (path):
    os.chmod (path, 0755)

def visit (arg, path, files):
    for dir in excluded_dirs:
	if os.path.samefile (path, dir):
	    return
    for filename in files:
	file = os.path.join (path, filename)
	if os.path.isfile (file):
	    (base, ext) = os.path.splitext (filename)
	    targetpath = src2targetpath (path)
	    if not os.path.exists (targetpath):
		os.mkdir (targetpath)
	    if ext in [".pre", ".prehtml"]:
		newext = ".html"
	    elif ext in [".html", ".cgi", ".gif", ".jpg", ".png", ".css"]:
		newext = ext
	    else:
		newext = ""
	    newfile = os.path.join (targetpath, base + newext)

	    if newext and (age (file) > age (newfile)):
		f = open (file, "r")
		text = f.read ()
		newf = open (newfile, "w")
		if ext == ".pre":
		    newtext = pre2html (base, text)
		    newf.write (newtext)
		elif ext == ".prehtml":
		    newf.write (prehtml2html (file))
		elif ext == ".cgi":
		    newf.write (text)
		    make_executable (newfile)
		elif ext in [".html", ".jpg", ".gif", ".png", ".css"]:
		    newf.write (text)
		newf.close ()
		print newfile

def main ():
    os.path.walk (source_dir, visit, None)

    ### peculiarities
    # bh.html
    #bh_source = os.path.join (dest_dir, "bh/bh.html")
    #bh_dest   = os.path.join (dest_dir, "bh.html")
    #if os.path.exists (bh_dest):
    #	os.remove (bh_dest)
    #os.symlink (bh_source, bh_dest)
    # spot sources

if __name__ == "__main__": # or sys.argv[0] == __name__:
    main ()
