;;; html-package.scm

(define-interface schemed-html-interface
  (export
   schemed-html->html
   doctype-html4.0
   link
   with-title
   with-heading
   listing
   separate-with
   dot-sep
   and-sep
   category
   indented-listing
   comment
   p
   br
   cite
   ))

(define-interface tools-interface
  (export
   (when :syntax)
   (unless :syntax)
   (case-equal :syntax)
   (bind :syntax)
   read-all
   ensure-executable
   tree-for-each
   (warning :syntax)
   last
   latest
   ))


(define-structure schemed-html schemed-html-interface
  (open scheme scsh tools)
  (files schemed-html))

(define-structure plain
  (export plain-file->html)
  (open scheme scsh)
  (files plain))

(define-structure prehtml
  (export prehtml->html)
  (open scheme scsh)
  (files prehtml))

(define-structure tools tools-interface
  (open scheme scsh)
  (files tools))

(define-structure symlink-tree
  (export symlink-tree)
  (open scheme scsh tools)
  (files symlink-tree))

(define-structure convert
  (export convert)
  (open scheme scsh tools schemed-html plain prehtml symlink-tree)
  (files convert))
